#include <bits/stdc++.h>

using namespace std;

int niz[500005];
int ispis[500005];


int main ()
{
    int n,k;
    cin >> n >> k;
    bool pr2 = true;
    for(int i=0;i<n;i++)
    {
        cin >> niz[i];
    }
    /*if(true/*pr2)
    {
        for(int i=0;i<n;i++)
        {
            if(niz[i] == 1 && k>0)
            {
                ispis[i]=-1;
                k--;
            }
        }
        if(k!=0)
        {
            for(int i=0;i<n;i++)
            {
                if(niz[i] == 0  && k>0)
                {
                    ispis[i]=-1;
                    k--;
                }
            }
        }
        for(int i=0;i<n;i++)
        {

            if(ispis[i] == 0) cout << niz[i] << " ";
        }
    }*/
    int p=0;
    int t=0;
    while(p<n && t < k)
    {
        while(niz[p] < niz[p+1])
        {
            p++;
        }
        ispis[p]=-1;
        p++;
        t++;
    }
    for(int i=0;i<n;i++)
    {
        if(ispis[i]==0)
            cout << niz[i] << " ";
    }

}